#!/usr/bin/python
# -*- coding: utf-8 -*-

# замыкания - closure

def multiplier( n ): # "multiplier возвращает функцию, умножающую на n"
    def mul( k ):
        return n * k
    return mul

# multiplier = lambda n: lambda k: n * k

mul3 = multiplier( 3 )  # mul3 - функция, умножающая на 3
print mul3( 3 ), mul3( 5 )
