#!/usr/bin/python
# -*- coding: utf-8 -*-

# замыкания - closure
def addClosure( val1 ):
    def closure( val2 ):
        return val1 + val2
    return closure
cl = addClosure( 3 )

# эквивалентный функтор 
class addFunctor:
    def __init__( self, val1 ):
        self.val1 = val1
    def __call__( self, val2 ):
        return self.val1 + val2
fn = addFunctor( 3 )

# частичное применение функции
from  functools import partial
def addPart( a, b ): return a + b
pr = partial( addPart, 3 )


print cl( 2 ), fn( 2 ), pr( 2 )  # напечатает: 5 5 5
